var weatherChannel = {};
var urls = 1;
var radarScript = "radar.php";
weatherChannel.mapURLs = [];

weatherChannel.getURLS = function(mapObj) {
  // Map is at a specific location
  var searchPage;
  var findRequest = null;
  if (mapObj.map == 0) {
    if (!validateZIPCode(mapObj.regioncode)) {
      mapObj.locationID = getMapID(mapObj.regioncode);
    }
    searchPage = "http://www.dividedsoul.net/RadarInMotion/maps/" + radarScript + "?zipcode=" + (validateZIPCode(mapObj.regioncode) ? mapObj.regioncode : mapObj.locationID);
    var tableZip = null;
    findRequest = new XMLHttpRequest();
    findRequest.open("GET", searchPage, false);
    findRequest.send(null);
    if (findRequest.readyState != 4 || findRequest.status != 200) {
      mapObj.alert.visibility = "visible";
      mapObj.alert.background = "#283f8d";
      mapObj.alert.innerHTML = "Warning: Map could not be loaded1";
      document.getElementById("weatherURL").style.visibility = "hidden";
      document.getElementById("status").style.visibility = "hidden";
      return;

    }
    // All warnings are included in <td> tag with class "module"
    var hrefText = findRequest.responseText.split("\n");
    if (hrefText.length != 3) {
      mapObj.alert.visibility = "visible";
      mapObj.alert.background = "#283f8d";
      mapObj.alert.innerHTML = "Warning: Map could not be loaded1";
      document.getElementById("weatherURL").style.visibility = "hidden";
      document.getElementById("status").style.visibility = "hidden";
      return;
    }

    var mapOptions = [];
    if (hrefText[0] != "-") {
      mapObj.storeMapURL("600M", hrefText[0]);
    }
    if (hrefText[1] != "-") {
      mapObj.storeMapURL("300M", hrefText[1]);
    }
    if (hrefText[2] != "-") {
      mapObj.storeMapURL("100M", hrefText[2]);
    }
  }
  // Map is regional
  else {
    mapObj.mapOptions[0] = [];
    mapObj.mapOptions[0][0] = null;

    searchPage = "http://www.dividedsoul.net/RadarInMotion/maps/" + radarScript + "?index=" + mapObj.map;
    findRequest = new XMLHttpRequest();
    findRequest.open("GET", searchPage, false);
    findRequest.send(null);
    if (findRequest.readyState != 4 || findRequest.status != 200) {
      mapObj.alert.visibility = "visible";
      mapObj.alert.background = "#283f8d";
      mapObj.alert.innerHTML = "Warning: Map could not be loaded1";
      document.getElementById("weatherURL").style.visibility = "hidden";
      document.getElementById("status").style.visibility = "hidden";
      return;
    }
    mapObj.mapOptions[0][1] = findRequest.responseText;
  }
  document.getElementById("weatherURL").visibility = "visible";
};

weatherChannel.getMapID = function(locID) {
  var splitStr = locID.split(",", 2);
  if (splitStr[0] == null && splitStr[1] == null)
    return null;

  var city = splitStr[0];
  var state = null;
  if (splitStr[1] != null)
    state = splitStr[1];
  else
    state = "";
  var searchPage = "http://www.dividedsoul.net/RadarInMotion/maps/fetch.php?city=" + city.replace(/^\s+|\s+$/g, "") + "&state=" + state.replace(/^\s+|\s+$/g, "");
  var tableZip = null;
  var findRequest = null;
  findRequest = new XMLHttpRequest();
  findRequest.open("GET", searchPage, false);
  findRequest.send(null);
  if (findRequest.readyState == 4 && findRequest.status == 200) {
    // All warnings are included in <td> tag with class "module"
    var hrefText = findRequest.responseText.split("\n");
    if (hrefText.length > 1)
      tableZip = hrefText[0];

  }
  return tableZip;
};

weatherChannel.getMaps = function(mapObj) {
  if (mapObj.mapOptions.length == 0) {
    document.getElementById("warning").style.visibility = "visible";
    document.getElementById("warning").style.background = "#283f8d";
    document.getElementById("warning").innerHTML = "Warning: Map could not be loaded1";
    document.getElementById("weatherURL").style.visibility = "hidden";
    document.getElementById("status").style.visibility = "hidden";
  } else {
    var uniquej = new Date();
    var uniquei = "?" + uniquej.getTime();
    if (actualSaveMaps > 0 && mapObj.map < 69) {
      var cutoffTime = mapObj.lastUpdated == null ? "" : ("-z \"" + (mapObj.lastUpdated.toGMTString()) + "\" ");
      if (mapObj.mapOptions[mapObj.currentMap][0] == null || mapObj.mapOptions[mapObj.currentMap][0].indexOf("Forecast") == -1) {
        for (mapIndex = 1; mapIndex <= 5; mapIndex++) {
          var nextTime = (new Date()).getTime();
          var index = widget.system("/usr/bin/curl " + cutoffTime + "-o \"" + folder + "/" + nextTime +
            ".jpg\" " + mapObj.mapOptions[mapObj.currentMap][1] + mapIndex + "L.jpg" + uniquei, null).errorString.indexOf("100");
          if (index > -1) {
            mapObj.maps[mapObj.maps.length] = folder + "/" + nextTime + ".jpg";
          }
          document.getElementById("warning").innerHTML = "Loading Maps: " + mapIndex + "/5";
        }
      }
      // Last updated is last modified date of most recent map
      mapObj.lastUpdated = new Date(widget.system("/usr/bin/curl -I " + mapObj.mapOptions[mapObj.currentMap][1] + 5 + "L.jpg" + uniquei, null).outputString.split("\n")[3].substring(15));
      // Remove old maps
      mapObj.removeOldMaps();

    } else {
      if (mapObj.map < 69) {
        for (mapIndex = 1; mapIndex <= 5; mapIndex++) {
          if (mapObj.currentMap >= mapObj.mapOptions.length) mapObj.currentMap = 0;
          mapObj.maps[mapIndex - 1] = mapObj.mapOptions[mapObj.currentMap][1] + mapIndex + "L.jpg" + uniquei;
          document.getElementById("warning").innerHTML = "Loading Maps: " + mapIndex + "/5";
        }
      } else {
        var now = new Date().getHours();
        var days = (now < 13 && now > 3) ? 2 : 3;
        var nights = (days == 2) ? 1 : 2;
        for (mapIndex = 1; mapIndex <= 7; mapIndex++) {
          if (days == 2 || mapIndex != 1) {
            if (mapObj.map == 69)
              mapObj.maps[2 * mapIndex - days] = (mapObj.mapOptions[mapObj.currentMap][1].replace("hi$$", "hi" + mapIndex)) + uniquei;
            else if (mapObj.map >= 70 && mapObj.map <= 78)
              mapObj.maps[2 * mapIndex - days] = ((mapObj.map == 71 && mapIndex > 1 && mapIndex < 8) ?
                (mapObj.mapOptions[mapObj.currentMap][1].replace("day$$", "day" + mapIndex).replace("usec", "use")) :
                (mapObj.mapOptions[mapObj.currentMap][1].replace("day$$", "day" + mapIndex))) + uniquei;
            else if (mapObj.map >= 88 && mapObj.map <= 96)
              mapObj.maps[2 * mapIndex - days] = ((mapObj.map == 89 && mapIndex < 8) ?
                (mapObj.mapOptions[mapObj.currentMap][1].replace("day$$", "day" + mapIndex).replace("usec", "use")) :
                ((mapObj.map == 95) ?
                  mapObj.mapOptions[mapObj.currentMap][1].replace("day$$", "day" + mapIndex).replace("uswc", "usw") :
                  mapObj.mapOptions[mapObj.currentMap][1].replace("day$$", "day" + mapIndex)
                )) + uniquei;
            else
              mapObj.maps[2 * mapIndex - days] = (mapObj.mapOptions[mapObj.currentMap][1].replace("day$$", "day" + mapIndex)) + uniquei;
          }
          if (mapObj.map == 69)
            mapObj.maps[2 * mapIndex - nights] = (mapObj.mapOptions[mapObj.currentMap][1].replace("hi$$", "lo" + mapIndex)) + uniquei;
          else if (mapObj.map >= 79 && mapObj.map <= 87)
            mapObj.maps[2 * mapIndex - nights] = mapObj.mapOptions[mapObj.currentMap][1].replace("day$$", "night" + mapIndex).replace("hi", "lo") + uniquei;
          else
            mapObj.maps[2 * mapIndex - nights] = mapObj.mapOptions[mapObj.currentMap][1].replace("day$$", "night" + mapIndex).replace("hi", "lo") + uniquei;
        }
      }
      mapObj.lastUpdated = new Date();
    }
    if (mapObj.map == 0 && actualShowAlerts) mapObj.getAlerts();
  }
};